require 'socket'

host = if ARGV[0] then ARGV[0] else 'localhost' end
port = if ARGV[1] then ARGV[1] else 12345 end
socket = TCPSocket.open(host, port)
q_number = -1

th_get = Thread.start {
  while msg = socket.gets
    if msg =~ /^#(\d+): /
      q_number = $1.to_i
      msg = $'
    end
    print msg
  end
}

th_ans = Thread.start {
  while msg = STDIN.gets
    socket.write(q_number.to_s + ':' + msg)
  end
  socket.shutdown(1)
}

th_get.join
th_ans.exit if th_ans.alive?
socket.close
